// Cross-Browser Rich Text Editor
// http://www.kevinroth.com/rte/demo.htm
// Written by Kevin Roth (kevin@NOSPAMkevinroth.com - remove NOSPAM)

//init variables
var isRichText = false;
var rng;
var currentRTE;
var allRTEs = "";

var isIE;
var isGecko;
var isSafari;
var isDocAll;

var imagesPath;
var includesPath;
var cssFile;


function initRTE(imgPath, incPath, css) {
	//set browser vars
	var ua = navigator.userAgent.toLowerCase();
	isIE = ((ua.indexOf("msie") != -1) && (ua.indexOf("opera") == -1) && (ua.indexOf("webtv") == -1)); 
	isGecko = (ua.indexOf("gecko") != -1);
	isSafari = (ua.indexOf("safari") != -1);
	isDocAll = (isDocAll)?true:false;
	
	//check to see if designMode mode is available
	if (document.getElementById && document.designMode && !isSafari) {
		isRichText = true;
	}
	
	//set paths vars
	imagesPath = imgPath;
	includesPath = incPath;
	cssFile = css;
	
	//for testing standard textarea, uncomment the following line
	//isRichText = false;
}

function writeRichText(rte, html, width, height, buttons, readOnly) {
	if (isRichText) {
		if (allRTEs.length > 0) allRTEs += ";";
		allRTEs += rte;
		writeRTE(rte, html, width, height, buttons, readOnly);
	} else {
		writeDefault(rte, html, width, height, buttons, readOnly);
	}
}

function writeDefault(rte, html, width, height, buttons, readOnly) {
	if (!readOnly) {
		document.writeln('<textarea name="' + rte + '" id="' + rte + '" style="width: ' + width + 'px; height: ' + height + 'px;">' + html + '</textarea>');
	} else {
		document.writeln('<textarea name="' + rte + '" id="' + rte + '" style="width: ' + width + 'px; height: ' + height + 'px;" readonly>' + html + '</textarea>');
	}
}

function writeRTE(rte, html, width, height, buttons, readOnly) {
	if (readOnly) buttons = false;
	if (buttons == true) {
		document.writeln('<style type="text/css">');
		document.writeln('.btnImage {cursor: pointer; cursor: hand;}');
		document.writeln('</style>');
// menu starts here
//		document.writeln('<div class="menu" onClick="activateRTE(\'' + rte + '\')">');
		document.writeln('<div class="menu">');
// copy paste menu (first row)
		document.writeln('<div class="dt right" id="Buttons1_' + rte + '" style="visibility: hidden;">');
// not yet implemented somehow, need to look into that
		if (isIE) {
			document.writeln('<img class="btnImage" src="' + imagesPath + 'copy.png" width="18" height="18" alt="Copy" title="Copy" onClick="FormatText(\'' + rte + '\', \'copy\')" /></td>');
			document.writeln('<img class="btnImage" src="' + imagesPath + 'cut.png" width="18" height="18" alt="Cut" title="Cut" onClick="FormatText(\'' + rte + '\', \'cut\')" />');
			document.writeln('<img class="btnImage" src="' + imagesPath + 'paste.png" width="18" height="18" alt="Paste" title="Paste" onClick="FormatText(\'' + rte + '\', \'paste\')" /></td>');
			document.writeln('<span>&nbsp;</span>');
		}

        if (false) { // those annoying buttons are useless anyway
		    document.writeln('<img class="btnImage" src="' + imagesPath + 'undo.png" width="18" height="18" alt="Undo" title="Undo" onClick="FormatText(\'' + rte + '\', \'undo\')" /></td>');
    		document.writeln('<img class="btnImage" src="' + imagesPath + 'redo.png" width="18" height="18" alt="Redo" title="Redo" onClick="FormatText(\'' + rte + '\', \'redo\' /)"></td>');
        }
		document.writeln('</div>');

// bold italic menu (second row)
		document.writeln('<div id="Buttons2_' + rte + '" style="visibility: hidden;">');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'b.png" width="18" height="18" alt="Bold" title="Bold" onClick="FormatText(\'' + rte + '\', \'bold\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'i.png" width="18" height="18" alt="Italic" title="Italic" onClick="FormatText(\'' + rte + '\', \'italic\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'u.png" width="18" height="18" alt="Underline" title="Underline" onClick="FormatText(\'' + rte + '\', \'underline\', \'\')" />');
		document.writeln('<span>&nbsp;</span>');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'alignleft.png" width="18" height="18" alt="Align Left" title="Align Left" onClick="FormatText(\'' + rte + '\', \'justifyleft\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'aligncenter.png" width="18" height="18" alt="Center" title="Center" onClick="FormatText(\'' + rte + '\', \'justifycenter\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'alignright.png" width="18" height="18" alt="Align Right" title="Align Right" onClick="FormatText(\'' + rte + '\', \'justifyright\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'justify.png" width="18" height="18" alt="Justify Full" title="Justify Full" onclick="FormatText(\'' + rte + '\', \'justifyfull\', \'\')" />');
		document.writeln('<span>&nbsp;</span>');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'ol.png" width="18" height="18" alt="Ordered List" title="Ordered List" onClick="FormatText(\'' + rte + '\', \'insertorderedlist\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'ul.png" width="18" height="18" alt="Unordered List" title="Unordered List" onClick="FormatText(\'' + rte + '\', \'insertunorderedlist\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'unquote.png" width="18" height="18" alt="Outdent" title="Outdent" onClick="FormatText(\'' + rte + '\', \'outdent\', \'\')" />');
		document.writeln('<img class="btnImage" src="' + imagesPath + 'blockquote.png" width="18" height="18" alt="Indent" title="Indent" onClick="FormatText(\'' + rte + '\', \'indent\', \'\')" />');
		document.writeln('<span>&nbsp;</span>');
		document.writeln('<div id="forecolor_' + rte + '"><img class="btnImage" src="' + imagesPath + 'colour.png" width="18" height="18" alt="Text Color" title="Text Color" onClick="FormatText(\'' + rte + '\', \'forecolor\', \'\')" /></div>');
		document.writeln('<span>&nbsp;</span>');
// new link dialog
		document.writeln('<img class="btnImage" src="' + imagesPath + 'biglink.png" width="18" height="18" alt="insert link" title="insert link" onClick="SelectLink(\'' + rte + '\')">'); /* end new link dialog */
		document.writeln('<img class="btnImage" src="' + imagesPath + 'image.png" width="18" height="18" alt="Add Image" title="Add Image" onClick="SelectImage(\'' + rte + '\')" />');
		document.writeln('</div>');
		document.writeln('</div>');
	}
// menu finished
// start the iframe
	document.writeln('<iframe class="htmlarea" id="' + rte + '" name="' + rte + '"  height="' + height + 'px"></iframe>');

// expert view
	if (!readOnly) document.writeln('<div class="extra"><div class="right" id="Buttons3_'+ rte +'" style="visibility: hidden;"><small><label for="chkSrc' + rte + '">expert view</label></small><input type="checkbox" id="chkSrc' + rte + '" onclick="toggleHTMLSrc(\'' + rte + '\');" /></div></div>');


// hidden color palette
// random is for refreshing, can be removed after testing
	document.writeln('<iframe width="254" height="174" id="cp' + rte + '" src="' + includesPath + 'palette.htm?' + Math.random() + '" marginwidth="0" marginheight="0" scrolling="no" style="visibility:hidden; display: none; position: absolute;"></iframe>');

// this hidden field might be usefull for caret positioning?
	document.writeln('<input type="hidden" id="hdn' + rte + '" name="' + rte + '" value="">');
	document.getElementById('hdn' + rte).value = html;
    // turned off, must be activated manually
	enableDesignMode(rte, html, readOnly);
}

function enableDesignMode(rte, html, readOnly) {
	var oRTE;

	var frameHtml = "<html id=\"" + rte + "\">\n<head>\n";
	// references the stylesheet
	if (cssFile.length > 0) {
		frameHtml += "<link media=\"all\" type=\"text/css\" href=\"" + cssFile + "\" rel=\"stylesheet\">\n";
	}
//	frameHtml += "<style>\nbody {\nbackground: #FFFFFF;\nmargin: 2px;\npadding: 0px;\n}\n</style>\n</head>\n<body>\n";
	frameHtml += "<style>\nbody {\nbackground: #FFFFFF;\nmargin: 2px;\npadding: 0px;\n}\n</style>\n</head>\n<body>\n";
	frameHtml += html + "\n";
	frameHtml += "</body>\n</html>";
	
	if (isDocAll) {
		oRTE = frames[rte].document;
		oRTE.open();
		oRTE.write(frameHtml);
		oRTE.close();
	} else {
		try {
			try {
				oRTE = document.getElementById(rte).contentWindow.document;
				oRTE.open();
				oRTE.write(frameHtml);
				oRTE.close();
				if (isGecko && !readOnly) {
					//attach a keyboard handler for gecko browsers to make keyboard shortcuts work
					oRTE.addEventListener("keypress", kb_handler, true);
				}
			} catch (e) {
				alert("Error preloading content.");
			}
		} catch (e) {
			//gecko may take some time to enable design mode.
			//Keep looping until able to set.
			if (isGecko) {
				setTimeout("enableDesignMode('" + rte + "', '" + html + "', " + readOnly + ");", 10);
			} else {
				return false;
			}
		}
	}
//	return true;
}

function activateRTE (rte) {
	var oRTE;
	if (isIE && (frames.length > 0)) {
        // if there are no editors, don't enable them
        // which makes the javascript behave nicely on msie
        // when there are no richt text areas visible
		oRTE = frames[rte].document;
        oRTE.designMode = "On";
        // show menus
		document.getElementById("Buttons1_" + rte).style.visibility = "visible";
		document.getElementById("Buttons2_" + rte).style.visibility = "visible";
		document.getElementById("Buttons3_" + rte).style.visibility = "visible";
        // alert ("activated " + rte + " the msie way");
	} else {
        try {
            document.getElementById(rte).contentDocument.designMode = "on";
            // show menus
    		document.getElementById("Buttons1_" + rte).style.visibility = "visible";
    		document.getElementById("Buttons2_" + rte).style.visibility = "visible";
    		document.getElementById("Buttons3_" + rte).style.visibility = "visible";
            // alert ("activated " + rte + " the firefox way");
        } catch (e) {
            //if (confirm("whoops @: " +rte + "\nretry?")) {
                setTimeout("activateRTE('" + rte + "');", 150);
            //}
        }
    }
}

function activateRTEs(allRTEs) {
//    alert ("all RTEs: " + allRTEs);
	var vRTEs = allRTEs.split(";");
	for (var i = 0; i < vRTEs.length; i++) {
//        activateRTE(vRTEs[i]);
        if (isIE) {
		    activateRTE(vRTEs[i]);
    	} else {
            setTimeout("activateRTE('" + vRTEs[i] + "');", 150);
        }
	}
}

function deactivateRTE (rte) {
	var oRTE;
	updateRTE(rte);
	if (isIE) {
		oRTE = frames[rte].document;
		oRTE.designMode = "Off";
	} else {
		document.getElementById(rte).contentDocument.designMode = "off";
    }
}

function updateRTEs() {
	var vRTEs = allRTEs.split(";");
	for (var i = 0; i < vRTEs.length; i++) {
		updateRTE(vRTEs[i]);
	}
}

function updateRTE(rte) {
	//set message value
	var oHdnMessage = document.getElementById('hdn' + rte);
	var oRTE = document.getElementById(rte);
	var readOnly = false;
	
	//check for readOnly mode
	if (isIE) {
		if (!frames[rte]) {
			return true;
		} else { 
			if (frames[rte].document.designMode != "On") readOnly = true;
		}
	} else {
		if (!document.getElementById(rte)) {
			return true;
		} else { 
			if (document.getElementById(rte).contentDocument.designMode != "on") readOnly = true;
		}
	}
	
	if (isRichText && !readOnly) {
		// if viewing source, switch back to design view -> not enabled for msie
		if (!isIE && document.getElementById("chkSrc" + rte).checked) {
			document.getElementById("chkSrc" + rte).checked = false;
			toggleHTMLSrc(rte);
		}
		
		if (oHdnMessage.value == null) oHdnMessage.value = "";
		if (isIE) {
			oHdnMessage.value = frames[rte].document.body.innerHTML;
		} else {
			oHdnMessage.value = oRTE.contentWindow.document.body.innerHTML;
		}
		//if there is no content (other than formatting) set value to nothing
		if (stripHTML(oHdnMessage.value.replace("&nbsp;", " ")) == "") oHdnMessage.value = "";
		//fix for gecko
		if (escape(oHdnMessage.value) == "%3Cbr%3E%0D%0A%0D%0A%0D%0A") oHdnMessage.value = "";
	}
}

function toggleHTMLSrc(rte) {
	//contributed by Bob Hutzel (thanks Bob!)
	var oRTE;
	var htmlSrc;
	if (isIE) {
		oRTE = frames[rte].document;
	} else {
		oRTE = document.getElementById(rte).contentWindow.document;
	}
	
	if (document.getElementById("chkSrc" + rte).checked) {
		document.getElementById("Buttons1_" + rte).style.visibility = "hidden";
		document.getElementById("Buttons2_" + rte).style.visibility = "hidden";
		if (isIE) {
			oRTE.body.innerText = oRTE.body.innerHTML;
		} else {
			htmlSrc = oRTE.createTextNode(oRTE.body.innerHTML);
			oRTE.body.innerHTML = "";
			oRTE.body.appendChild(htmlSrc);
		}
	} else {
		document.getElementById("Buttons1_" + rte).style.visibility = "visible";
		document.getElementById("Buttons2_" + rte).style.visibility = "visible";
		if (isIE) {
			oRTE.body.innerHTML = oRTE.body.innerText;
		} else {
			htmlSrc = oRTE.body.ownerDocument.createRange();
			htmlSrc.selectNodeContents(oRTE.body);
			oRTE.body.innerHTML = htmlSrc.toString();
		}
	}
}

//Function to format text in the text box
function FormatText(rte, command, option) {
	var oRTE;
	var selection;
	if (isIE) {
		oRTE = frames[rte];
		
		//get current selected range
		selection = oRTE.document.selection; 
		if (selection != null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	try {
		if ((command == "forecolor") || (command == "hilitecolor")) {
			//save current values
			parent.command = command;
			currentRTE = rte;
			
			//position and show color palette
			var buttonElement = document.getElementById(command + '_' + rte);
			document.getElementById('cp' + rte).style.left = getOffsetLeft(buttonElement) + "px";
			document.getElementById('cp' + rte).style.top = (getOffsetTop(buttonElement) + buttonElement.offsetHeight) + "px";
			if (document.getElementById('cp' + rte).style.visibility == "hidden") {
				document.getElementById('cp' + rte).style.visibility = "visible";
				document.getElementById('cp' + rte).style.display = "inline";
			} else {
				document.getElementById('cp' + rte).style.visibility = "hidden";
				document.getElementById('cp' + rte).style.display = "none";
			}
		} else if (command == "createlink") {
			var szURL = prompt("Enter a URL:", "");
			try {
				//ignore error for blank urls
				oRTE.document.execCommand("Unlink", false, null);
				oRTE.document.execCommand("CreateLink", false, szURL);
			} catch (e) {
				//do nothing
			}
		} else {
			//oRTE.focus();
		  	oRTE.document.execCommand(command, false, option);
			//oRTE.focus();
		}
	} catch (e) {
		alert(e);
	}
}

// function to insert text
function AddText( rte, insText ) {
	var oRTE;
	var fullText;
	var selection;
	if (isIE) {
		oRTE = frames[rte];
		//get current selected range
		selection = oRTE.document.selection; 
		if (selection != null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
        /* stupid msie doesn't know what range. */
	}
	if ((insText != null) && (insText != "")) {
		oRTE.focus();
		fullText = oRTE.window.document.body.innerHTML;
		//alert ("full text before: " + fullText);
		var szURL = "http://placeholder";
		//alert ("placeholder: " + szURL + " for: " + insText);
		try {
			//ignore error for blank urls
			oRTE.document.execCommand("InsertImage", false, szURL);
			//alert ("placeholder inserted");
		} catch (e) {
			//do nothing
		}
		updateRTE(rte);
		fullText = oRTE.window.document.body.innerHTML;
		//alert ("full text placeholder: " + fullText);
		var phPattern = new RegExp("<img\\ssrc=\"http:\\/\\/placeholder\">","i");
		fullText = fullText.replace(phPattern, insText);
		//alert ("placeholder replaced - result: " + fullText);
		oRTE.window.document.body.innerHTML = fullText;
		updateRTE(rte);
		fullText = oRTE.window.document.body.innerHTML;
		//alert ("full text after: " + fullText);
	}
	oRTE.focus();
}

//Function to add link
function SelectLink(rte) {
	var szURL = richPopUp("linkselect.php?rte="+rte, 'links', '600', '400');
}

// function to insert text
function InsertText( rte, insText ) {
	var oRTE;
	var fullText;
	var selection;
	if (isIE) {
		oRTE = frames[rte];
		//get current selected range
		selection = oRTE.document.selection; 
		if (selection != null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
        /* stupid msie doesn't know what range. */
	}
	if ((insText != null) && (insText != "")) {
		oRTE.focus();
		fullText = oRTE.window.document.body.innerHTML;
		//alert ("full text before: " + fullText);
		var szURL = "http://placeholder";
		//alert ("placeholder: " + szURL + " for: " + insText);
		try {
			//ignore error for blank urls
			oRTE.document.execCommand("InsertImage", false, szURL);
			//alert ("placeholder inserted");
		} catch (e) {
			//do nothing
		}
		updateRTE(rte);
		fullText = oRTE.window.document.body.innerHTML;
		//alert ("full text placeholder: " + fullText);
		var phPattern = new RegExp("<img\\ssrc=\"http:\\/\\/placeholder\">","i");
		fullText = fullText.replace(phPattern, insText);
		//alert ("placeholder replaced - result: " + fullText);
		oRTE.window.document.body.innerHTML = fullText;
		updateRTE(rte);
		fullText = oRTE.window.document.body.innerHTML;
		//alert ("full text after: " + fullText);
	}
	oRTE.focus();
}

//Function to set color
function setColor(color) {
	var rte = currentRTE;
	var oRTE;
	if (isDocAll) {
		oRTE = frames[rte];
	} else {
		oRTE = document.getElementById(rte).contentWindow;
	}
	
	var parentCommand = parent.command;
	if (isDocAll) {
		//retrieve selected range
		var sel = oRTE.document.selection; 
		if (parentCommand == "hilitecolor") parentCommand = "backcolor";
		if (sel != null) {
			var newRng = sel.createRange();
			newRng = rng;
			newRng.select();
		}
	} else {
		//oRTE.focus();
	}
	oRTE.document.execCommand(parentCommand, false, color);
	//oRTE.focus();
	document.getElementById('cp' + rte).style.visibility = "hidden";
	document.getElementById('cp' + rte).style.display = "none";
}


//Function to select Image
function SelectImage(rte) {
	var szURL = richPopUp("imageselect.php?rte="+rte, 'images', '750', '450');
}
//Function to add image
function AddImage(rte, imagePath) {
	var oRTE;
	var selection;
	if (isIE) {
		oRTE = frames[rte];
		
		//get current selected range
		selection = oRTE.document.selection; 
		if (selection != null) {
			rng = selection.createRange();
		}
        
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
        /* stupid msie doesn't know what range. */
	}
	if (imagePath==null) {
	    imagePath = prompt('Enter Image URL:', 'http://');
    }
	if ((imagePath != null) && (imagePath != "")) {
		oRTE.focus();
		oRTE.document.execCommand('InsertImage', false, imagePath);
	}
	oRTE.focus();
}

//function to perform spell check
function checkspell() {
	try {
		var tmpis = new ActiveXObject("ieSpell.ieSpellExtension");
		tmpis.CheckAllLinkedDocuments(document);
	}
	catch(exception) {
		if(exception.number==-2146827859) {
			if (confirm("ieSpell not detected.  Click Ok to go to download page."))
				window.open("http://www.iespell.com/download.php","DownLoad");
		} else {
			alert("Error Loading ieSpell: Exception " + exception.number);
		}
	}
}

function getOffsetTop(elm) {
	var mOffsetTop = elm.offsetTop;
	var mOffsetParent = elm.offsetParent;
	
	while(mOffsetParent){
		mOffsetTop += mOffsetParent.offsetTop;
		mOffsetParent = mOffsetParent.offsetParent;
	}
	
	return mOffsetTop;
}

function getOffsetLeft(elm) {
	var mOffsetLeft = elm.offsetLeft;
	var mOffsetParent = elm.offsetParent;
	
	while(mOffsetParent) {
		mOffsetLeft += mOffsetParent.offsetLeft;
		mOffsetParent = mOffsetParent.offsetParent;
	}
	
	return mOffsetLeft;
}

function Select(rte, selectname) {
	var oRTE;
	var selection;
	if (isDocAll) {
		oRTE = frames[rte];
		
		//get current selected range
		selection = oRTE.document.selection; 
		if (selection != null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	var idx = document.getElementById(selectname).selectedIndex;
	// First one is always a label
	if (idx != 0) {
		var selected = document.getElementById(selectname).options[idx].value;
		var cmd = selectname.replace('_' + rte, '');
		oRTE.document.execCommand(cmd, false, selected);
		document.getElementById(selectname).selectedIndex = 0;
	}
	//oRTE.focus();
}

function kb_handler(evt) {
	var rte = evt.target.id;
	
	//contributed by Anti Veeranna (thanks Anti!)
	if (evt.ctrlKey) {
		var key = String.fromCharCode(evt.charCode).toLowerCase();
		var cmd = '';
		switch (key) {
			case 'b': cmd = "bold"; break;
			case 'i': cmd = "italic"; break;
			case 'u': cmd = "underline"; break;
		};

		if (cmd) {
			FormatText(rte, cmd, true);
			//evt.target.ownerDocument.execCommand(cmd, false, true);
			// stop the event bubble
			evt.preventDefault();
			evt.stopPropagation();
		}
 	}
}

function docChanged (evt) {
	alert('changed');
}

function stripHTML(oldString) {
	var newString = oldString.replace(/(<([^>]+)>)/ig,"");
	
	//replace carriage returns and line feeds
   newString = newString.replace(/\r\n/g," ");
   newString = newString.replace(/\n/g," ");
   newString = newString.replace(/\r/g," ");
	
	//trim string
	newString = trim(newString);
	
	return newString;
}

function trim(inputString) {
   // Removes leading and trailing spaces from the passed string. Also removes
   // consecutive spaces and replaces it with one space. If something besides
   // a string is passed in (null, custom object, etc.) then return the input.
   if (typeof inputString != "string") return inputString;
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
	
   while (ch == " ") { // Check for spaces at the beginning of the string
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length-1, retValue.length);
	
   while (ch == " ") { // Check for spaces at the end of the string
      retValue = retValue.substring(0, retValue.length-1);
      ch = retValue.substring(retValue.length-1, retValue.length);
   }
	
	// Note that there are two spaces in the string - look for multiple spaces within the string
   while (retValue.indexOf("  ") != -1) {
		// Again, there are two spaces in each of the strings
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ")+1, retValue.length);
   }
   return retValue; // Return the trimmed string back to the user
}

function richPopUp ( url, name, width, height, scrollbars ) { 
	// popup as window 
	// just your average centered popup with some sensible defaults
	if ( scrollbars == null ) {
		scrollbars = "1";
	}
	if ( !name ) {
		name = "richpop";
	}
	if ( !width ) {
		width = "500";
	}
	if ( !height ) {
		height = "400";
	}
 
	var str  = ""; 
	str += "resizable=1,"; 
	str += "scrollbars=" + scrollbars + ","; 
	str += "width=" + width + ","; 
	str += "height=" + height + ","; 
 
	if ( window.screen ) { 
		var ah = screen.availHeight - 30; 
		var aw = screen.availWidth - 10; 
 
		var xc = ( aw - width ) / 2; 
		var yc = ( ah - height ) / 2; 
 
		str += ",left=" + xc + ",screenX=" + xc; 
		str += ",top=" + yc + ",screenY=" + yc; 
	}
	var remote = window.open( url, name, str ); 

	if (remote.opener == null)
		{	// if something went wrong
			remote.opener = window;
		}
	remote.opener.name = window.name;
	return remote;

}

// function must be called on every form submit
function submitForm() {
	//make sure hidden and iframe values are in sync before submitting form
	//to sync only 1 rte, use updateRTE(rte)
	//to sync all rtes, use updateRTEs
	//updateRTE('rte1');
	//updateRTE('chars[4][txtval]');
	//updateRTE('chars[5][txtval]');
	updateRTEs();
	//change the following line to true to submit form
	return true;
}